#ifndef SIGNAL_H
#define SIGNAL_H

#include <X11/X.h>
#include <Xm/DrawingA.h>


class SIGNAL
{
  public :
    enum TYPE
    {
      CONTINOUS,
      DISCRETE
    };

    enum COLOR
    {
      BLACK,
      GREY,
      WHITE,
      RED,
      ORANGE,
      YELLOW,
      GREEN,
      BLUE,
      VIOLETT,
      BROWN
    };

            SIGNAL      (const char *Name, int Size,
	 	         Widget Parent, Widget Top, TYPE Type = CONTINOUS);
           ~SIGNAL      ();

    void    Clear       ();
    void    AddValue    (double Value);
    
    void    SetName     (const char *Name);
    void    SetValue    (int Index, double Value);
    void    SetZoomX    (double FactorX);
    void    SetZoomY    (double FactorY);
    void    SetColor    (COLOR Color);

    void    SetPos      (int Pos);
    void    Select      (int From, int To);

    double  GetValue    (int Index) const;
    double  GetZoomX    () const;
    double  GetZoomY    () const;

    void    Refresh     ();
    Widget  GetWidget   ();

  public :
    Pixmap  Pic;
    int     Sel1, Sel2;

// Save

  private :
    // Methods:
    void    Update      ();
    void    Redraw      ();

    // Attributes:
    char    Name[20];
    int     Size;
    int     SizeX, SizeY;
    double  ZoomX, ZoomY;
    double *Values;
    TYPE    Type;
    Pixel   bg, fg;
    int     Index;
    int     MidY;
    Widget  Form;
    Widget  Label, Area;
    Window  Win;
};



#endif
